; EGR 270 - Lab 8 - Circuit 1
; Project name:  Blink LED on Arduino Nano pin D8 at 1 Hz
; Created: 3/10/20xx 2:17:17 PM
; Author : John Doe

.DEF dly1 = R17					// Assign the name dly1 to R17
.DEF dly2 = R18
.DEF dly3 = R19

 .ORG   0x0000                  // Store program at address 0x0000 in flash memory
 RJMP   main                    // Program begins at the main label

 main:
 LDI    r16, 0xFF               // Load the immedate value 0xFF (all bits 1) into register 16
 OUT    DDRB, r16               // Set Data Direction Register B to output for all pins

 loop:
 SBI    PortB, 0                // Set bit 0 of PortB. (i.e. turn on the LED)
                                // Notes:  PB0 maps to pin D8 on the Arduino Nano
								//         Refer to Pin Mapping Table in the class notes
 RCALL  delay_500ms             // Call delay_500ms subprogram to keep LED lit for 0.5s
 CBI    PortB, 0                // Clear bit 0 of PortB. (i.e. turn off the LED)
 RCALL  delay_500ms             // Call delay_500ms subprogram to keep LED off for 0.5s
 RJMP   loop                    // Loop again

 // Everything beneath is part of the delay subprogram (or subroutine)
 // Note that 8 bit registers hold a max value of 255 (unsigned) so creating a 0.5 s delay requires using a triple nested loop.
Delay_500ms:                ; For CLK(CPU) = 16 MHz (clock rate for Arduino Nano) - Lab test showed 60 blinks in 1 minute test
                            ; T = 1/16MHz = 62.5 ns.  Delay = 62.5ns(8,000,000 cycles) = 0.5s
    LDI     dly1,   64      ; One clock cycle: outer loop: 64 * 125000 cycles = 8,000,000 cycles
Delay1:
    LDI     dly2,   125     ; One clock cycle: middle loop:  125 * 1000 cycles = 125000 cycles
Delay2:
    LDI     dly3,   250     ; One clock cycle: inside loop: 4 cycles * 250 = 1000 cycles
Delay3:
    DEC     dly3            ; One clock cycle
    NOP                     ; One clock cycle
    BRNE    Delay3          ; Two clock cycles when jumping to Delay3, 1 clock when continuing to DEC

    DEC     dly2            ; One clock cycle
    BRNE    Delay2          ; Two clock cycles when jumping to Delay2, 1 clock when continuing to DEC

    DEC     dly1            ; One clock Cycle
    BRNE    Delay1          ; Two clock cycles when jumping to Delay1, 1 clock when continuing to RET
RET							; Return to main (end of subprogram)
